﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using RDotNet;

namespace RtoCSharp
{
    
    class clsRtoCS
    {
        
        REngine engine = REngine.GetInstance();
        

        public NumericMatrix runCreditMetrics(NumericMatrix CTMC, NumericVector exposureCount, NumericVector simNumber, 
                             NumericVector riskLessRate, NumericVector EAD_per_Exposure, NumericVector OverallLGD, NumericVector corr, 
                                    CharacterVector BorrowerRatings, NumericVector ConfidenceLevel, NumericMatrix rho, 
                                         CharacterVector CopulaType, NumericVector df, string getPath)
         {
            engine.Initialize();

            engine.SetSymbol("CTMC", CTMC);
            engine.SetSymbol("exposureCount", exposureCount);
            engine.SetSymbol("simNumber", simNumber);
            engine.SetSymbol("riskLessRate", riskLessRate);
            engine.SetSymbol("EAD_per_Exposure", EAD_per_Exposure);
            engine.SetSymbol("OverallLGD", OverallLGD);
            engine.SetSymbol("rho", rho);
            engine.SetSymbol("BorrowerRatings", BorrowerRatings);
            engine.SetSymbol("ConfidenceLevel", ConfidenceLevel);
            engine.SetSymbol("CopulaType", CopulaType);
            engine.SetSymbol("df", df);
            string completePath = "source('" + getPath + "/CreditMetrics.R')";
            engine.Evaluate(completePath);

            engine.Dispose();

            NumericMatrix cm_CVaR = engine.Evaluate(" cm.CVaR(CTMC,OverallLGD,EAD_per_Exposure,exposureCount,simNumber,riskLessRate,rho," +
                                              "ConfidenceLevel,BorrowerRatings,CopulaType, df)").AsNumericMatrix();

            return cm_CVaR;

         }


        //Here we randomly generate a portfolio 
        public DataFrame RandomPortfolio(string getPath)
         {
            engine.Initialize();

            string completePath = "source('" + getPath + "/GenerateRandomPortfolio.R')";
            engine.Evaluate(completePath);
            DataFrame getPortfolio = engine.Evaluate("GenerateRandomPortfolio()").AsDataFrame();

            engine.Dispose();

            return getPortfolio;

         }


        //use random portfolio to generate a continuous time markov chain
        public NumericMatrix getTransitionMatrix(DataFrame getPortfolio, string getPath)
         {
            engine.Initialize();

            engine.SetSymbol("getPortfolio", getPortfolio);     //convert to (getPortfolio is the randomly generated portfolio) 
            string completePath = "source('" + getPath + "/ContinuousTimeMarkovChain.R')";
            engine.Evaluate(completePath);
            NumericMatrix CTMC = engine.Evaluate("ContinuousTimeMarkovChain(getPortfolio)").AsNumericMatrix();

            engine.Dispose();

            return CTMC;
         }

       
    }

    
}
